SystemOrganization addCategory: #'Caitlin-World'!

Object subclass: #CWPerson
	instanceVariableNames: 'personName room'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Caitlin-World'!

!CWPerson class methodsFor: 'as yet unclassified' stamp: 'srh 11/5/2006 23:11'!
name: aName in: aRoom
	^super new personName: aName; room: aRoom; yourself! !

!CWPerson class methodsFor: 'as yet unclassified' stamp: 'srh 11/5/2006 23:14'!
new
	^self error: 'Use name: in: instead'.! !

!CWPerson methodsFor: 'as yet unclassified' stamp: 'srh 11/5/2006 23:05'!
back
	room lastRoom
		ifNil: [Transcript show: 'You can''t go that way!!';cr ]
		ifNotNil: [ room := room lastRoom. ].
	self status.! !

!CWPerson methodsFor: 'as yet unclassified' stamp: 'srh 11/5/2006 22:54'!
describe
	Transcript show: 'I am ', personName, ' and I am '.
	room 
		ifNotNil: [Transcript show: 'in ', room roomName]
		ifNil: [Transcript show: 'nowhere'].

	Transcript cr.! !

!CWPerson methodsFor: 'as yet unclassified' stamp: 'srh 11/5/2006 23:05'!
forward
	room nextRoom 
		ifNil: [Transcript show: 'You can''t go that way!!';cr ]
		ifNotNil: [ room := room nextRoom. ].
	self status.! !

!CWPerson methodsFor: 'as yet unclassified' stamp: 'srh 11/5/2006 22:58'!
look
	room 
		ifNil: [Transcript show: 'You can''t see anything.  Are you lost?']
		ifNotNil: [Transcript show: room describe].

	Transcript cr.! !

!CWPerson methodsFor: 'accessing' stamp: 'srh 11/5/2006 22:49'!
personName
	^personName! !

!CWPerson methodsFor: 'accessing' stamp: 'srh 11/5/2006 22:49'!
personName: anObject
	personName := anObject! !

!CWPerson methodsFor: 'accessing' stamp: 'srh 11/5/2006 22:49'!
room
	^room! !

!CWPerson methodsFor: 'accessing' stamp: 'srh 11/5/2006 22:49'!
room: anObject
	room := anObject! !

!CWPerson methodsFor: 'as yet unclassified' stamp: 'srh 11/5/2006 23:04'!
status
	"I show the current status of the person"
	Transcript show: 'In ', room roomName; cr.! !

Object subclass: #CWRoom
	instanceVariableNames: 'roomName description nextRoom lastRoom'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Caitlin-World'!

!CWRoom methodsFor: 'as yet unclassified' stamp: 'srh 11/5/2006 22:45'!
describe
	| cr |
	cr := String cr.
	^	'=== ' , roomName , ' ===', cr,
		description, cr,
		'---', cr,
		(lastRoom
			ifNotNil: ['Behind you is ', lastRoom roomName, '. ']
			ifNil: ['']),
		(nextRoom 
			ifNotNil: ['The next room is ', nextRoom roomName]
			ifNil: ['You can go no farther']).! !

!CWRoom methodsFor: 'accessing' stamp: 'srh 11/5/2006 20:01'!
description
	^description! !

!CWRoom methodsFor: 'accessing' stamp: 'srh 11/5/2006 20:01'!
description: anObject
	description := anObject! !

!CWRoom methodsFor: 'accessing' stamp: 'srh 11/5/2006 22:41'!
lastRoom
	^lastRoom! !

!CWRoom methodsFor: 'accessing' stamp: 'srh 11/5/2006 22:41'!
lastRoom: anObject
	lastRoom := anObject! !

!CWRoom methodsFor: 'accessing' stamp: 'srh 11/5/2006 22:32'!
nextRoom
	^nextRoom! !

!CWRoom methodsFor: 'accessing' stamp: 'srh 11/5/2006 22:32'!
nextRoom: anObject
	nextRoom := anObject! !

!CWRoom methodsFor: 'accessing' stamp: 'srh 11/5/2006 20:01'!
roomName
	^roomName! !

!CWRoom methodsFor: 'accessing' stamp: 'srh 11/5/2006 20:01'!
roomName: anObject
	roomName := anObject! !
